<?php
 
 
 

namespace PhpWA\Protocol\Proto\MessageAddOn;

use UnexpectedValueException;




class MessageAddOnType
{
    


    const UNDEFINED = 0;
    


    const REACTION = 1;
    


    const EVENT_RESPONSE = 2;
    


    const POLL_UPDATE = 3;
    


    const PIN_IN_CHAT = 4;

    private static $valueToName = [
        self::UNDEFINED => 'UNDEFINED',
        self::REACTION => 'REACTION',
        self::EVENT_RESPONSE => 'EVENT_RESPONSE',
        self::POLL_UPDATE => 'POLL_UPDATE',
        self::PIN_IN_CHAT => 'PIN_IN_CHAT',
    ];

    public static function name($value)
    {
        if (!isset(self::$valueToName[$value])) {
            throw new UnexpectedValueException(sprintf(
                    'Enum %s has no name defined for value %s', __CLASS__, $value));
        }
        return self::$valueToName[$value];
    }


    public static function value($name)
    {
        $const = __CLASS__ . '::' . strtoupper($name);
        if (!defined($const)) {
            throw new UnexpectedValueException(sprintf(
                    'Enum %s has no value defined for name %s', __CLASS__, $name));
        }
        return constant($const);
    }
}

